﻿package{
	import flash.display.*;
	import flash.events.Event;
	import flash.filters.BlurFilter;
	import flash.geom.Matrix;
	import flash.geom.Point;
	
	public class Perliner extends Sprite
	{
		private var bmd:BitmapData;
		private var background:Bitmap;
		private var angle:Number = 0;
		private var painter:Sprite;
		private var matrix:Matrix ;
		private var color:uint = 0xff0000;
		private var filterObj:BlurFilter = new BlurFilter(1,2,2);
		
		private var rot:Number;
		private var boom:Number=0;
		
		public function Perliner():void
		{
			addEventListener(Event.ADDED_TO_STAGE,addedHandler);
		}
		private function addedHandler(e:Event):void
		{
			bmd = new BitmapData(stage.stageWidth,stage.stageHeight,false,0xff000000);
			background = new Bitmap(bmd);
			addChild(background);
			painter = new Sprite();
			init();
			addEventListener(Event.ENTER_FRAME,enterHandler);
		}
		private function init():void
		{
			angle = 0;
			color = 0xffffff;
			painter.graphics.beginFill(color,1);
			painter.graphics.lineStyle(.8,0xffffff,1);
			painter.graphics.drawCircle(0,0,20);
			painter.graphics.endFill();
		}
		private function enterHandler(e:Event):void
		{
			boom= Math.random()*180;
			rot=-100*Math.sin(Math.PI / 180 * boom);
			boom+=20;
			
			if(angle<20){
				matrix = new Matrix();
				matrix.translate(mouseX,mouseY);
				matrix.rotate(angle++);
				bmd.applyFilter(bmd,bmd.rect,new Point(Math.cos(rot)*angle*3,Math.sin(rot)*angle*3),filterObj);
				bmd.draw(painter,matrix);
				angle+=3;
			}else{
				init();
				
			}
		}
	}
}